searchData={"items":[{"type":"module","doc":"Module to retrieve tracked paths.","title":"NavigationHistory","ref":"NavigationHistory.html"},{"type":"function","doc":"Retrieves the last tracked path.","title":"NavigationHistory.last_path/3","ref":"NavigationHistory.html#last_path/3"},{"type":"function","doc":"NavigationHistory.last_path(conn) # returns the last path visited\n    NavigationHistory.last_path(conn, 1) # returns the second last path visited\n    NavigationHistory.last_path(conn, default: \"/\")  # returns the last path and default to \"/\" if none available\n    NavigationHistory.last_path(conn, key: \"admin\") # returns the last path tracked by tracker with key \"admin\"\n    NavigationHistory.last_path(session) # instead of passing a conn, can also pass a session","title":"Examples - NavigationHistory.last_path/3","ref":"NavigationHistory.html#last_path/3-examples"},{"type":"function","doc":"Retrieves a list of last tracked paths.","title":"NavigationHistory.last_paths/2","ref":"NavigationHistory.html#last_paths/2"},{"type":"function","doc":"NavigationHistory.last_paths(conn)\n    NavigationHistory.last_paths(session)\n    NavigationHistory.last_paths(conn, key: \"admin\")","title":"Examples - NavigationHistory.last_paths/2","ref":"NavigationHistory.html#last_paths/2-examples"},{"type":"module","doc":"A plug to track user navigation history.\n\nVisited paths will be stored in the session by the plug.\nThe paths can then be accessed with `NavigationHistory.last_path` and\n`NavigationHistory.last_paths`.\n\nThe session must already be fetched with `Plug.Conn.fetch_session/1`.","title":"NavigationHistory.Tracker","ref":"NavigationHistory.Tracker.html"},{"type":"module","doc":"* `:excluded_paths` - The list of paths which should not be tracked.\n      For example, `/login` or similar for a lot of apps.\n      Defaults to `[]`\n  * `:included_paths` - Limits list the paths to be tracked when set.\n      `:excluded_paths` is ignored if set.\n  * `:methods` - The list methods which should be tracked.\n      Defaults to `[\"GET\"]`\n  * `:history_size` - The number of history entries to track in `last_paths`.\n      Defaults to `10`.\n  * `:key` - The key used to track the navigation.\n      It can also be passed to `:last_path` and `:last_paths` to retrieve the paths for the\n      relevant key.\n      Defaults to `\"default\"`.\n  * `:accept_duplicates` - By default, if the same URL is repeated, it is ignored, unless this\n      option is set to `true`.\n      Defaults to `false`.","title":"Options - NavigationHistory.Tracker","ref":"NavigationHistory.Tracker.html#module-options"},{"type":"module","doc":"plug NavigationHistory.Tracker, excluded_paths: [\"/login\", ~r(/admin.*)], history_size: 5","title":"Examples - NavigationHistory.Tracker","ref":"NavigationHistory.Tracker.html#module-examples"},{"type":"function","doc":"Callback implementation for  Plug.call/2 .","title":"NavigationHistory.Tracker.call/2","ref":"NavigationHistory.Tracker.html#call/2"},{"type":"function","doc":"Callback implementation for  Plug.init/1 .","title":"NavigationHistory.Tracker.init/1","ref":"NavigationHistory.Tracker.html#init/1"},{"type":"function","doc":"","title":"NavigationHistory.Tracker.track_history/2","ref":"NavigationHistory.Tracker.html#track_history/2"},{"type":"extras","doc":"Copyright (c) 2016 Daniel Perez\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the \"Software\"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","title":"License","ref":"license.html"},{"type":"extras","doc":"# NavigationHistory\n\n![Build status](https://github.com/danhper/plug-navigation-history/actions/workflows/ci.yml/badge.svg)\n[![Module Version](https://img.shields.io/hexpm/v/navigation_history.svg)](https://hex.pm/packages/navigation_history)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/navigation_history/)\n[![Total Download](https://img.shields.io/hexpm/dt/navigation_history.svg)](https://hex.pm/packages/navigation_history)\n[![License](https://img.shields.io/hexpm/l/navigation_history.svg)](https://github.com/danhper/plug_navigation_history/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/danhper/plug-navigation-history.svg)](https://github.com/danhper/plug-navigation-history/commits/master)\n\nA plug to keep track of user navigation history using sessions.\nThis can be useful for example to redirect the user back to the previous page,\nor to redirect after a login when the user tried to access a page without being\nauthenticated.","title":"NavigationHistory","ref":"readme.html"},{"type":"extras","doc":"Add `:navigation_history` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:navigation_history, \"~> 0.4\"}\n  ]\nend\n```","title":"Installation - NavigationHistory","ref":"readme.html#installation"},{"type":"extras","doc":"To keep track of the navigation, add the `NavigationHistory.Tracker` plug.\nFor example, in a Phoenix application, your pipeline could become:\n\n```elixir\npipeline :browser do\n  plug :accepts, [\"html\"]\n  plug :fetch_session\n  plug :fetch_flash\n  plug :protect_from_forgery\n  plug :put_secure_browser_headers\n  plug NavigationHistory.Tracker\nend\n```\n\nYou can then retrieve the paths the user navigated to by using\n\n```elixir\nNavigationHistory.last_path(conn) # will return the last navigated path or nil\nNavigationHistory.last_path(conn, 1) # will return the second last navigated path\nNavigationHistory.last_path(conn, default: \"/\") # will return the last path or \"/\"\nNavigationHistory.last_paths(conn) # will return a list of the last navigated paths\nNavigationHistory.last_path(session) # instead of passing a conn, can also pass a session\n```\n\nFor example, to redirect the user to the last navigated path in Phoenix, you can use\na helper like this\n\n```elixir\ndef redirect_back(conn, opts \\\\ []) do\n  Phoenix.Controller.redirect(conn, to: NavigationHistory.last_path(conn, opts))\nend\n\n# you can then write\nredirect_back(conn, default: \"/\")\n```\n\nTake a look at [this conversation](https://github.com/phoenixframework/phoenix/pull/1402) in Phoenix for more info about redirecting back.","title":"Usage - NavigationHistory","ref":"readme.html#usage"},{"type":"extras","doc":"There are a few options that can be used with the plug:\n\n  * `excluded_paths` - The list of paths which should not be tracked.\n      For example, `/login` or similar for a lot of apps.\n      Defaults to `[]`\n  * `included_paths` - Limits list the paths to be tracked when set.\n      `excluded_paths` is ignored if set.\n  * `methods` - The list methods which should be tracked.\n      Defaults to `[\"GET\"]`\n  * `history_size` - The number of history entries to track in `last_paths`.\n      Defaults to `10`.\n  * `key` - The key used to track the navigation.\n      It can also be passed to `last_path` and `last_paths` to retrieve the paths for the\n      relevant key.\n      Defaults to `\"default\"`.\n  * `accept_duplicates` - By default, if the same URL is repeated, it is ignored, unless this\n      option is set to `true`.\n      Defaults to `false`.","title":"Configuration - NavigationHistory","ref":"readme.html#configuration"},{"type":"extras","doc":"```elixir\nplug NavigationHistory.Tracker, excluded_paths: [\"/login\", ~r(/admin.*)]\nplug NavigationHistory.Tracker, included_paths: [~r(/admin.*)], key: \"admin\", history_size: 5\n\n# which an be used\nNavigationHistory.last_path(conn) # from default history\nNavigationHistory.last_path(conn, key: \"admin\") # from admin history\n```\n\nSince OTP 28, regular expressions are not supported at compile time, so you need to initialize the tracker at runtime.\nThis can be done with the following code:\n\n```elixir\nplug :track_history\n\ndefp track_history(conn, opts) do\n  opts = Keyword.put(opts, :excluded_paths, [\"/login\", ~r(/admin.*)])\n  NavigationHistory.Tracker.track_history(conn, opts)\nend\n```","title":"Examples - NavigationHistory","ref":"readme.html#examples"},{"type":"extras","doc":"Copyright (c) 2016 Daniel Perez\n\nReleased under the MIT License, which can be found in the repository in [LICENSE](./LICENSE).","title":"Copyright and License - NavigationHistory","ref":"readme.html#copyright-and-license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}